const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const tenants = sequelize.define(
    'tenants',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

tenant_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"individual",


"company"

        ],

      },

email: {
        type: DataTypes.TEXT,
      
      

      },

phone: {
        type: DataTypes.TEXT,
      
      

      },

billing_address: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  tenants.associate = (db) => {

    db.tenants.belongsToMany(db.tags, {
      as: 'tags',
      foreignKey: {
        name: 'tenants_tagsId',
      },
      constraints: false,
      through: 'tenantsTagsTags',
    });

    db.tenants.belongsToMany(db.tags, {
      as: 'tags_filter',
      foreignKey: {
        name: 'tenants_tagsId',
      },
      constraints: false,
      through: 'tenantsTagsTags',
    });


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity










    db.tenants.hasMany(db.leases, {
      as: 'leases_tenant',
      foreignKey: {
          name: 'tenantId',
      },
      constraints: false,
    });























//end loop



    db.tenants.belongsTo(db.companies, {
      as: 'company',
      foreignKey: {
        name: 'companyId',
      },
      constraints: false,
    });




    db.tenants.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.tenants.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return tenants;
};


